package com.bcxin.event.core.definitions;

import com.bcxin.event.core.exceptions.IllegalArgumentEventException;
import lombok.Data;
import org.apache.commons.lang3.StringUtils;

@Data
public class JdbcConnectorDefinition extends ConnectorDefinitionAbstract {

    @Override
    public String getConnector() {
        return ConnectorConstants.JDBC;
    }

    private String url;
    private String username;
    private String password;
    private String tableName;
    private String connectionTimeZone;

    public String getJdbcDefinitionMeta() {
        if (StringUtils.isEmpty(this.getTableName())) {
            throw new IllegalArgumentEventException(
                    String.format("JdbcConnectorDefinition(%s)的TableName不能为空",
                            this.getUrl())
            );
        }

        return String.format(
                "'connector' = '%s','url'='%s','username'='%s','password'='%s','table-name'='%s'",
                this.getConnector(), this.getUrl(),
                this.getUsername(), this.getPassword(),
                this.getTableName());
    }

    public String getUniqueKey() {
        return String.format("%s-%s", this.getUrl(), this.getUsername());
    }
}
