package com.bcxin.event.core.utils;

import freemarker.cache.StringTemplateLoader;
import freemarker.template.Configuration;
import freemarker.template.Template;

import java.io.StringWriter;

public class FreemarkerUtils {

    private static String defaultCharacter = "UTF-8";
    private static Configuration cfg;

    private FreemarkerUtils() {
    }

    static {
        cfg = new Configuration();
        cfg.setDefaultEncoding(defaultCharacter);
        cfg.setTagSyntax(Configuration.AUTO_DETECT_TAG_SYNTAX);
    }

    public static String processTemplate(String myTemplate, Object data){
        String result = null;
        String name = "template";

        try {
            StringTemplateLoader stringTemplateLoader = new StringTemplateLoader();
            stringTemplateLoader.putTemplate(name, myTemplate);
            cfg.setTemplateLoader(stringTemplateLoader);
            Template template = cfg.getTemplate(name, defaultCharacter);
            StringWriter out = new StringWriter();
            template.process(data, out);
            out.flush();
            result = out.toString();
            out.close();
        } catch (Exception e){
            e.printStackTrace();
        }
        return result;
    }

}
